> For the complete documentation index, see [llms.txt](https://docs.optondemand.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.optondemand.com/integrations-and-apps/rest-api/api-structure/authentication.md).

# Authentication

Verify your identity to grant access to the API

## Overview

This API uses OAuth Client Credentials Flow for secure machine-to-machine authentication. This authentication method follows the OAuth 2.0 specification (RFC 6749, section 4.4).

## Getting Started

#### 1. Request Credentials

Before you can authenticate contact our team to obtain your unique Client ID and Client Secret

#### 2. Generate Access Token

Once you have your credentials, you can use it to obtain temporary access token. You must monitor access token expiration date and build mechanism to fetch new access token once it expires.

Please don't abuse our auth server by requesting access tokens frequently before its expiration or for each API call.&#x20;

```
curl --request POST \
  --url https://auth.integrations.optondemand.com/oauth/token \
  --header 'Content-Type: application/json' \
  --data '{
    "client_id": "YOUR_CLIENT_ID",
    "client_secret": "YOUR_CLIENT_SECRET",
    "grant_type": "client_credentials"
  }'
```

#### 3. Use the Token

Include the access token in all API requests:

```
Authorization: Bearer YOUR_ACCESS_TOKEN
```


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.optondemand.com/integrations-and-apps/rest-api/api-structure/authentication.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
